// WOCIMAGE.PRG - UTILIDAD DE WOCUL3.EXE - NOV.2000 - JUAN PLANELLES.
// Using MDIChildren with user defined styles                  
 
#INCLUDE "FiveWin.ch"
//#include "InKey.ch"
#include "Image.ch"

// Lines Styles
#define LINES_NONE            0
#define LINES_BLACK           1
#define LINES_GRAY            2
#define LINES_3D              3
#define LINES_DOTED           4

//#define WM_MDIGETACTIVE     553   // 0x0229
#define K_ESC       27
#define HORZRES     8	//10	//8
#define VERTRES     10	//11	//10
#define PLANES      15     

STATIC oWnd, oWndChild, oHand, oLbxB1,;
        cFileImg, cFileBmp, cFIni, cSel, ;
        bGFile, bRun, bChange
Static aImg, nImgAnt, aResp, aObjBmp
Static oBar, oC2, oCarga, oMru1, oMru2, oMru4, ;
       oLi1, oLi2, oLi4, oBo1, oBo2, oBo4, oIco
Static oSv, oS1, oS2, oBmpVer, oCoors
Static lPsico := .f., lStat := .f., lExist := .f., lSel := .t.
Static lUsImg := .t., bVer := {|| Nil }, ;
             bImg := {|| Nil }, bSalva := {|| Nil }, bLis := {|| Nil }
//-------------------------------------------------------------//

FUNCTION Main( nUser )
//   LOCAL oBar  //, oHand //, bGFile //, cFileBmp := ''
   LOCAL cApp, cIniFile := GetWinDir()+"\FiveWin.ini", oFont, bResp
   Local oSalir, oAbrir, oImpr, oSalvar, oRun, cMasc, cTxt, nTotal
   Local cFileSv, oFBt
local cTarget := Upper( HB_CurDrive() ) + ':', bDir, ;
        cFile := 'SELED.', nI := 0, aD := {}
local aLis := {}, aDir := {}
local bCarp   := {|| Nil }, cFNam := '', cTemp := '', cDirAct
local cExt := '001'

   DEFAULT nUser := 1
 
      SET DATE BRITISH
      SET CENTURY ON
      SET MULTIPLE ON
 //     SET _3DLOOK ON
      SetHandleCount( 250 )

aResp := {}
aImg    := {}
aObjBmp := {}

cExt := PADL( AllTrim( str( nUser, 3 ) ), 3, "0" )
cFile := cFile + cExt

// Se anula con nueva libreria FW28
//lUsImg := iif( File( cFile ) .or. ( IsWinNt() ), .f., lUsImg )

cTarget := cTarget + '\' + CurDir( cTarget )        //"C:\" + CurDir( "C:" )
cDirAct := cTarget

cTemp   := 'W' + 'IMG' + cExt // carpeta para ver
                        // imagenes temporales en XP desde explorer
cTarget := cTarget + '\' + cTemp

bDir := { | carpeta | ;
                iif( !File( carpeta ), ;
                        lMkDir( carpeta ), Nil ) ;
                }

Eval( bDir, cTarget )   // Se crea la carpeta si no la habia

if year( date() ) >= 2000 .or. Year( date() ) == 00     // Siglo XXI ..
	SET EPOCH TO 2000
endif
if year( date() ) >= 2100 .or. Year( date() ) == 00     // Siglo XXI ..
        SET EPOCH TO 2100
endif

   if !( lUsImg ) 

        // Vaciado de carpeta antes de usarla ..
        aDir := Directory( cTarget + '\' + '*.*' )
        aEval( aDir, {| aV | ;
                    cFNam := aV[ 1 ], ;   
                    cFNam := cTarget + '\' + cFileName( cFNam ), ;
                    iif( File( cFNam ), Ferase( cFNam ), Nil ) } )

        bLis := {|| ;
        aLis := {}, ;
        aEval( aImg, {| c, n | ;
               aadd( aLis, aImg[ n ] ) } ) ;
                  }
        Eval( bLis )    // Se cargan los nombres para la carpeta de marras..
 
    // Se pasan a la carpeta, se ven en explorer, se
   // salvan por si hay cambios, y se eliminan de la carpeta especial
        // Vaciar posibles ficheros restantes, antes
                                                                    
        bImg := {|| ;
        Eval( bLis ), ;
        aEval( aLis, { | c, n | ;
        aD := Directory( aLis[ n ] ), ;
        iif( File( aLis[ n ] ) .and. aD[ 1, 2 ] > 0, ;
              LZCopyFile( aLis[ n ], cTarget + '\' + ;
                        cFileName( aLis[ n ] ) ), Nil ) } ) ;
                  }
        Eval( bImg )

        bVer := {|| ;
                CursorWait(), ;
                Eval( bImg ), ;
               WAITRUN( 'EXPLORER' + ' ' + cTarget, 3 ), ;
                CursorWait(), Eval( bSalva ) ;
                        }

        bSalva := {|| ;
        aEval( aImg, {| c, n | ;
                aD := Directory( cTarget + '\' + cFileName( aImg[ n ] ) ), ;
                iif( File( cTarget + '\' + cFileName( aImg[ n ] ) ) .and. ;
                aD[ 1, 2 ] > 0, ;
               LZCopyFile( cTarget + '\' + cFileName( aImg[ n ] ), ;
                        aImg[ n ] ), Nil ) } ) ;
                        }
   endif




aResp   := {}
aImg    := {}
aObjBmp := {}
lPsico  := ( File( 'Resp1.Psi' ) ) //.and. 'PSI' $ Upper( cFIni ) )
if lPsico //.and. 'PSI' $ Upper( cFIni )
     cTxt := MemoRead( 'Resp1.Psi' )
           aResp := {}
           nTotal := MLCount( cTxt )
           For nI = 1 To nTotal
                    aadd( aResp, AllTrim( MemoLine( cTxt,, nI ) ) )
           Next
endif
bResp := {|| FResp() }
 
nImgAnt := 1
cFIni   := 'WOCIMAGE.INI' 
cSel    := ;
                    "Imagenes BMP   (*.bmp)| *.bmp|" +          ;
                             "DIB   (*.dib)| *.dib|" +          ;
                             "PCX   (*.pcx)| *.pcx|"  +         ;
                             "JPEG  (*.jpg)| *.jpg|" +          ;
                             "GIF   (*.gif)| *.gif|"  +         ;
                             "TARGA (*.tga)| *.tga|" +          ;
                             "RLE   (*.rle)| *.rle|" +          ;
		"Todos ( *.* ) | *.* "

bGFile := {| c | cFileBmp := cGetFile( ;
                                cSel, ;
                "Elija Fichero ", 01, ".\" ),;
                aD := Directory( cFileBmp ), ;
                iif( !Empty( cFileBmp ) .and. aD[ 1, 2 ] > 0, ;
            iif( Ascan( aImg, cFileBmp ) == 0 .or. ;
            MsgYesNo( OemToAnsi( 'Imagen: ' + cFileBmp + CRLF + ;
            'Ya se encuentra cargada' + CRLF + CRLF +;
            'CARGAR de NUEVO?' ) ),;
            ( oMru1:Save( cFileBmp ), oCarga:Enable(), ;
                            aadd( aImg, cFileBmp ),;
                        oLi1:Enable(), oBo1:Enable() ), Nil ), ;
                        lSel := .f. ) }

bRun := {|| ;
         cApp := cGetFile( '*.Exe' ), ;
         cApp := iif( Upper( cFileNoExt( cFileNoPath( cApp ) ) )$( ;
                                                'MSPAINT EXPLORER' ), ;
                cApp := cFileNoExt( cFileNoPath( cApp ) ), cApp ),;
         iif( !Empty( cApp ), ( oMru4:Save( cApp ), ;
         oBo4:Enable(), oLi4:Enable(),;
                iif( !Empty( cFileBmp ), ;
                        WaitRun( AllTrim( cApp ) + ;
                        ' ' + iif( Upper( cApp ) == 'EXPLORER', ;
              cFilePath( cFileBmp), cFileBmp ), '', 3  ), Nil ) ), Nil ) ;
        }

   DEFINE FONT oFont NAME 'Arial' SIZE 5, 11 BOLD    //0, -9 BOLD    //6, 13 BOLD
   DEFINE FONT oFBt  NAME 'Arial' SIZE 0, -10 ITALIC //BOLD    //0, -9 BOLD    //6, 13 BOLD

   DEFINE CURSOR oHand HAND
   DEFINE ICON oIco FILE 'FILE.ICO'
   DEFINE WINDOW oWnd                                           ;
      FROM 0, 0 To 25, 79                                       ;
      TITLE "WOCIMAGE.EXE - Utilidad de Wocul3.Exe (C) - 2005" ;
      ICON oIco ;
      MDI                                                       ;
      VSCROLL MENU BuildMenu( cTarget )  

   DEFINE BUTTONBAR oBar OF oWnd ;
      CURSOR oHand 

   DEFINE BUTTON OF oBar PROMPT "Exit" ;
      FONT oFBt  ;
     TOOLTIP 'Salir' ACTION oWnd:End()

   DEFINE BUTTON OF oBar PROMPT "Open"   ;
      FONT oFBt  ;
      TOOLTIP "Elegir Imagen"                 ;
      ACTION ( CreateChild( Eval( bGFile ) ), iif( lSel, ;
        aadd( aObjBmp, oBmpVer ), lSel := .t.) )

   DEFINE BUTTON OF oBar PROMPT "Prn"  ;
      FONT oFBt  ;
      TOOLTIP iif(  !( lUsImg ), ;
        OemToAnsi( 'Visor de Imgenes de Windows' ), "Imprimir Imagen" ) ;
      ACTION ( ;
      iif(  !( lUsImg ), Eval( bVer ), ;               
                IIF( oBmpVer != Nil, ;
                                        PrnBmp( , oBmpVer ),;
                MsgStop( 'NO se ha elegido IMAGEN !.' ) ) ),;
                cFileBmp := ;
                IIF( Empty( cFileBmp ) .and. (oLbxB1:nAt) > 0,;
                aImg[oLbxB1:nAt], cFileBmp ) )


   DEFINE BUTTON oSv OF oBar PROMPT "Save"  ; 
        FONT oFBt ;
        WHEN oBmpVer != Nil ;
        ACTION Copiar( cFileBmp, '', .f. ) ;
        TOOLTIP 'Copiar la imagen actual ..'

   DEFINE BUTTON OF oBar PROMPT "Run"  ;
        FONT oFBt ;
        ACTION  Eval( bRun ) ; 
        TOOLTIP 'Ejecutar un programa de dibujo ..'

//          oS2:SetText( 'R.:' + iif( Len( aResp ) >= oLbxB1:nAt, ;
  //                       aResp[oLbxB1:nAt], '' ) ), ;
//          oS2:SetText( 'R.:' + iif( EmpTy( aResp ), '', ;
  //                                      aResp[oLbxB1:nAt] ) ) ) ;
   @ 0.3, 40 COMBOBOX oLbxB1 VAR cFileImg ITEMS aImg ;
          OF oBar SIZE 300, 300 FONT oFont ;  
          ON CHANGE ( oS1:SetText( 'N:' + Str( oLbxB1:nAt, 3 ) ),;
          iif( lStat, ( iif( Len( aResp ) < Len( aImg ), ;
                Eval( bResp ), Nil ), cFileBmp := cFileImg, ;
          iif( lPsico, oS2:SetText( 'R.:' + aResp[oLbxB1:nAt] ), Nil ),;
       oWnd:Select( oLbxB1:nAt )  ), Nil ), ;
                oLbxB1:SetFocus(), cFileBmp := ;
                IIF( Empty( cFileBmp ) .and. (oLbxB1:nAt) > 0,;
                aImg[oLbxB1:nAt], cFileBmp ) );
          MESSAGE 'Imagenes usadas..'
        oLbxB1:oCursor := oHand                    
        oLbxB1:cToolTip := '<Intro> = Cambiar Foco a Ventana ..' 
        oLbxB1:bKeyChar := {|nKey, nFlags | FKeyChar( nKey, oLbxB1:nAt ) }
//        oLbxB1:bKeyDown := {|nKey, nFlags | FKeyChar( nKey, oLbxB1:nAt ) }
                                                                           
   @ 0.2, 35 SAY oS1 PROMPT '' BORDER SIZE 40, 18 ;
        COLOR CLR_HBLUE, CLR_WHITE CENTER       //RIGHT
        oS1:cToolTip := OemToAnsi( 'Nmero de Lnea Actual..' )

   @ 0.2, 25 SAY oS2 PROMPT '' BORDER SIZE 50, 18 ;
        COLOR CLR_HRED, CLR_WHITE CENTER
        oS2:bWhen := {||(lPsico)}    //RIGHT
        oS2:cToolTip := iif( (lPsico), 'Respuestas..', 'No ACIVO..' )

   oWnd:bKeyChar = { | nKey, nFlags | ;
                   iif( nKey == K_ESC, oWnd:End(), ;
                   FKeyChar( nKey ) ) }

   ACTIVATE WINDOW oWnd MAXIMIZED  ;
     ON INIT (;
                iif( Empty( oMru4:aItems ), ;
                  ( ;
                  oMru4:Save( 'EXPLORER' ), ;
        oMru4:Save( iif( IsWinNt(), 'MSPAINT', 'PBRUSH' ) ), ;
                oWnd:SetMenu( BuildMenu() ) ), Nil ),;
     IIF( File( cFIni ) .and. !EmpTy( MemoRead( cFIni ) ),;
         ( cMasc := AllTrim(MemoRead( cFIni )), ;
                cFileSv := StrTran( cMasc, '*', '@' ),;                
                cFileSv := StrTran( cFileSv, '?', '#' ),;
           iif( File( cFileSv ), ( ;
           CargaMasc( cMasc, .t., .t. ), oWndChild:Maximize(),;
           oC2:SetCheck( .t. ), cFileBmp := cFileImg := aImg[1], ;
                    Eval( bChange, cFileBmp ) ), ;
                        Alert( 'Fichero: ' + cFileSv + CRLF + ;
                                'NO ENCONTRADO !.' ) ) ), Nil ) );
          VALID ;
        MsgYesNo( 'Desea TERMINAR?', OemToAnsi( 'Archivo de Imgenes' ) )

        if ( lPsico )
                cTxt := ''             
                aEval( aResp, {|c,n| cTxt += Trim( aResp[n] ) + CRLF } )
                MemoWrit( 'Resp1.Psi', Trim( cTxt ) )
                xMsgList( aResp )
         endif 

RETURN( NIL )

//-------------------------------------------------------------//
Static Function FResp()
local n, nI := Len( aImg ) -Len( aResp )
if nI > 0
        For n = nI To Len( aImg )
            aadd( aResp, '' )
        Next
endif

Return Nil

Static Function FKeyChar( nKey, nAt )

if lPsico .and. Chr( nKey ) $ '1234'
//     aResp[ nAt ] := Chr( nKey )
     oS2:SetText( 'R.:' + Chr( nKey ) ) //aResp[nAt] )                             
endif

Return Nil

Function DefImage( Bmp )
Return TImage():Define( , Bmp )

Static Function FBmpVer( oBmpV, nRows, nCols )
Local nZoom
                oBmpVer := oBmpV
                nZoom:=oBmpV:Zoom()
      While oBmpVer:nWidth() >= oWnd:nHorzRes() -2*nCols .or. ;    
            oBmpVer:nHeight()>= oWnd:nVertRes() -5*nRows
          nZoom:=nZoom-(0.01)                   
          oBmpVer:Zoom(nZoom)
      end                                          
                                                 
Return nZoom

Static FUNCTION CreateChild( c1, l1 )  // cFileBmp )
//   LOCAL oWndChild
   LOCAL oBar, cFile := cFileBmp, oBmp, cChild 
   LOCAL cName := "Hello", nMaxHorz, nMaxVert, aCoor
   LOCAL oCbx, xItem, nI
   LOCAL hDC := GetDC(), WnAncho, WnAlto, hBmp
   Local nZoom, anchura, altura, nRatAncho, nRatAlto
   Local nCols, nRows, bAdjust

DEFAULT l1 := .t.       // Si se carga 1 o varios seguidos

if !( lUsImg )

     if ( l1 )
        Eval( bVer )
     endif

     Return( Nil )

endif

   if Empty( cFileBmp )  .or. !File( cFileBmp )
        cFileBmp := cFileImg
   endif
   if Empty( cFileBmp )  .or. !File( cFileBmp )
        MsgStop( OemToAnsi( 'NO se ha elegido' + CRLF +;
                ' NO se encuentra IMAGEN !.' ) )
        Return Nil
   endif

   bAdjust := {| o | iif( o != Nil, ( nZoom := oBmpVer:Zoom(),;
       oBmpVer:lStretch := !oBmpVer:lStretch,;
       oBmpVer:ScrollAdjust(), ;
       oWndChild:SetText( cChild + ' - ' + ;
            AllTrim( Str( nZoom*100, 05, ;
         iif( nZoom*100 == int( nZoom*100 ), 0, ;
         iif( SubsTr( Str( nZoom*100, 10, 2 ), ;
         at( '.', Str( nZoom*100, 10, 2 ))+1, 2 ) == '00', 0, 2 ) ) ) ) + ;
                                                '% = ' + cFile ), ;
       oBmpVer:Refresh( .t. ) ), Nil ) ;
                 }

    bChange := {|c,n| nI := n,;
        n := AScan( aImg, c ),;
        n := Max( 1, n ),;
        oLbxB1:SetItems( aImg ),;
        oLbxB1:Select( n ),;
        aResp := iif( Empty( aResp ), ;
               ( Array( Len( aImg ) ), aFill( aResp, '' ) ), aResp ),;
        oS1:SetText( 'N:' + Str( n, 3 ) ),;
        oS2:SetText( 'R.:' ),;  //+ aResp[nI] )
        oWnd:Select( oLbxB1:nAt ),;
        oBmpVer := iif( Len( aObjBmp ) >= n, aObjBmp[n], oBmp ),;
         oLbxB1:Refresh(),;
        oLbxB1:SetFocus() ;
                           }
   if !Empty( cFileBmp )
        oSv:Enable()
        cFileImg := cFileBmp
        Eval( bChange, cFileImg )
   endif

        nMaxHorz := oWnd:nHorzRes()       //GetDeviceCaps( hDC, HORZRES )
        nMaxVert := oWnd:nVertRes()       //GetDeviceCaps( hDC, VERTRES ) -125
        nCols  := oWnd:nHorzRes()/80
        nRows  := oWnd:nVertRes()/30

      // objeto virtual se crea para obtener datos
      oBmpVer := DefImage( cFileBmp )
      nZoom   := FBmpVer( oBmpVer, nRows, nCols )
      oBmpVer:Zoom( nZoom )
      anchura := oBmpVer:nWidth
      altura  := oBmpVer:nHeight
      oBmpVer:End()
                          
   DEFINE WINDOW oWndChild MDICHILD OF oWnd ICON oIco //PIXEL 
//   FROM 0, 0 TO 19*nRows, 46*nCols 

//      STYLE nOr( WS_CAPTION, WS_MINIMIZEBOX, WS_SYSMENU,        ;
//      WS_THICKFRAME )
                        
   @ 0, 0  IMAGE oBmpVer FILE cFileBmp PIXEL  ;
                SIZE anchura + 2, altura +2 ;
                ON LEFT CLICK Eval( bAdjust, oBmpVer ) ;
                OF oWndChild //SCROLL ADJUST

//                SIZE 45*nCols, 17*nRows

   oBmpVer:cToolTip := 'Click Izq. = Adjust ..'
   oBmpVer:oCursor := oHand
//   oBmpVer:nProgress:= 0     //( .f. )
//   oBmpVer:Progress( .f. )
   oWndChild:bGotFocus  = { || oLbxB1:Refresh(), ;
                               cFileBmp := cFile, ;
                               Eval( bChange, cFile ),;
                               nZoom := oBmpVer:Zoom() }

   oWndChild:bLostFocus = { || oBmp := oBmpVer } // Respalda el objeto
/*
        nRows  := oWnd:nVertRes()/30,;
    aCoor := GetCoors( oWndChild ),;
    oWndChild:Move( aCoor[1], aCoor[2], oBmpVer:nWidth() + 2, ;
                            oBmpVer:nHeight()  + 2 + 1.5*nRows ),;
*/
   oWndChild:oClient = oBmpVer                                      
   ACTIVATE WINDOW oWndChild  ON PAINT ( ;
       oLbxB1:SetFocus() ) ;              
      ON INIT ( ;
    iif( !Empty( cFileBmp ), ;
        ( cChild := oWndChild:cCaption, oBmpVer:Zoom( nZoom ), ;
       oWndChild:SetText( cChild + ' - ' + ;
            AllTrim( Str( nZoom*100, 05, ;
         iif( nZoom*100 == int( nZoom*100 ), 0, ;
         iif( SubsTr( Str( nZoom*100, 10, 2 ), ;
         at( '.', Str( nZoom*100, 10, 2 ))+1, 2 ) == '00', 0, 2 ) ) ) ) + ;
                                             '% = ' + cFile ) ), Nil ) );
    VALID ( ;
           ADEL( aResp, AsCan( aImg, cFileBmp ) ), ;
           ADEL( aObjBmp, AsCan( aImg, cFileBmp ) ), ;
           ADEL( aImg,  AsCan( aImg, cFileBmp ) ), ;
        ASIZE( aResp, Len( aResp ) -1 ), ;
        ASIZE( aObjBmp, Len( aObjBmp ) -1 ), ;
        ASIZE( aImg, Len( aImg ) -1 ),Eval( bChange, cFileBmp ), .t. )
                          
RETURN( NIL )                          
//-------------------------------------------------------------//

static function PrnBmp( Bmp, oBmp )
local oPrn
local nZoom:=oBmp:Zoom()
local anchura:=oBmp:nWidth()*nZoom
local altura :=oBmp:nHeight()*nZoom
DEFAULT Bmp := aImg[oLbxB1:nAt]

PRINT oPrn NAME "IMAGEN: " + Bmp PREVIEW
   PAGE
      oPrn:SayImage( 0, 0, obmp, anchura*4, altura*4)
//      oPrn:SayBitmap(0,0,bmp,anchura*4,altura*4)
   ENDPAGE
ENDPRINT
                oWnd:Select( oLbxB1:nAt )
                cFileBmp := ;
                IIF( Empty( cFileBmp ) .and. (oLbxB1:nAt) > 0,;
                aImg[oLbxB1:nAt], cFileBmp ) 

return nil

//*******************************************
STATIC function Copiar( cFileOrig, letra, lSelOrig, lImagen, lCambiar )
//*******************************************
local cFileDest := cFileOrig, nI

DEFAULT letra     := ''
DEFAULT lSelOrig  := .t.
DEFAULT lImagen   := .f.
DEFAULT lCambiar  := .f.
                      
if lSelOrig
          cFileOrig := ;
                cGFile( cFileOrig, letra, 'Elija Fichero de ORIGEN', lImagen )
endif

If !Empty( cFileOrig ) .and. File( cFileOrig )

	  cFileDest := cGFile( cFileName( cFileOrig ), letra, ;
                                        'Elija Fichero de DESTINO', lImagen )

	if Empty( cFileDest )
		MsgStop( OemToAnsi( 'No se ha elegido' + CRLF + ;
			' NO se encuentra' + CRLF + ;
			'Fichero de DESTINO' ) )
		Return nil
	endif
else
	MsgStop( OemToAnsi( 'No se ha elegido' + CRLF + ;
		' NO se encuentra' + CRLF + ;
		'Fichero de ORIGEN' ) )
	Return nil
endif

if !Empty( cFileOrig ) .and. !Empty( cFileDest )

    If !File( cFileDest ) .or. MsgYesNo( cFileDest + CRLF + ;
		'Ya existe' + CRLF + 'Desea Sobreescribir?' )
	if cFileDest == cFileOrig
		MsgStop( 'Fichero: ' + cFileOrig + CRLF + ;
			'No puede copiarse a si mismo..' )
	else 
		CursorWait()
		LZCopyFile( cFileOrig, cFileDest )
		CursorArrow()
		MsgInfo( 'ORIGEN: ' + cFileOrig + CRLF + ;
			'DESTINO: ' + cFileDest + CRLF + CRLF + 'Copia ' + ;
		iif( File( cFileDest ), '', 'NO' ) + ' Conseguida !..' )
              if lCambiar
                cFileBmp := cFileDest
                oWndChild:SetText( ;
                SubsTr( oWndChild:cCaption, 1, ;
                at( '=', oWndChild:cCaption ) ) + ' ' + cFileDest )
                nI := oLbxB1:nAt 
                aImg[ nI ] := cFileDest
                oLbxB1:SetItems( aImg )
                oLbxB1:Select( nI )
                oS1:SetText( 'N:' + Str( nI, 3 ) )
                oS2:SetText( 'R.:' + aResp[oLbxB1:nAt] )
                oLbxB1:Refresh()
              endif
	endif
    else
		MsgInfo( 'Copia NO efectuada ..' )
    endif

Endif

return Nil      //cFilePath( cFileDest )
//---------------------------
//******************************************
Static Function cGFile( cFile, letra, cTit, lImagen )
//******************************************
local cMasc := ''
local cPlt := cSel
DEFAULT letra   := '?'
DEFAULT lImagen := .f.
                   
cFile := iif( !Empty( cFile ), ( " (" + cFile + " ) |" +  cFile + "|" ), '' )
    cFile := cGetFile( cFile +  ;
	cPlt + ;
        "Todos ( *.* ) | *.* " , ;
	cTit, 01, ".\" )

Return cFile
//----------
//
Static Function FMasc( cMasc )
local uMasc := cMasc
uMasc := cFilePath( cMasc ) + '*.' + ;
              cFileExt( cFileNoPath( cMasc ) )  
    if MemoEdit( @uMasc, OemToAnsi( cMasc + " Poner smbolos de Mscara .." ),;
                ,,,,, OemToAnsi('Poner SIMBOLOS de Mscara: (? ), ( * )') )
        cMasc := uMasc
    endif           

Return AllTrim( cMasc )
//
Static Function CargaMasc( cMasc, lCargar, lInicio )
local aDirectorio := Directory( cMasc ), cTx
local fName, Fichero, nI, nTotal := Len( aDirectorio ), aD := {}
local aLista := {}, cLista := '', cFileSv := StrTran( cMasc, '*', '@' )
local nOpc   := 2       // Asi por omision
cFileSv := StrTran( cFileSv, '?', '#' )

DEFAULT lCargar := .t.
DEFAULT lInicio := .f.       // Llamada a carga automatica desde inicio

nOpc := iif( lInicio, 1, nOpc ) // p q salte directo

if nTotal == 0
     Return Nil
endif

For nI = 1 To nTotal // Crear lista con los nombres de los archivos hallados
    cFileBmp := aDirectorio[ nI, 1 ]
    cFileBmp := cFilePath( cMasc ) + cFileBmp
    if aDirectorio[ nI, 2 ] > 0 .and. ;
        !Empty( cFileBmp ) .and. File( cFileBmp ) .and.;
                !( '@'$ cFileBmp ) .and. !( '#'$ cFileBmp )
        
        if Ascan( aImg, cFileBmp ) == 0 // NO las mascaras
           aadd( aLista, cFileBmp )
        endif
    endif
Next
        if File( cFileSv )
        if !( lInicio )

           nOpc := Alert( 'La Lista de Archivos ya existe ..',;
                        { ' &Usarla ', ' &Rehacer ', ' &Editar ' },;
                                OemToAnsi('Mscara: ') + cMasc )
        endif
        else
        if lInicio
             Return Nil // No Hay
        endif
        endif

        if nOpc == 1 .or. nOpc == 3   // Usar sin editar,  editando
           cTx := cLista := MemoRead( cFileSv )
           aLista := {}
           nTotal := MLCount( cLista )
           // Crear la lista de nuevo los ya conformes..     
           For nI = 1 To nTotal
               if !EmpTy( AllTrim( MemoLine( cLista,, nI ) ) )
                   aadd( aLista, AllTrim( MemoLine( cLista,, nI ) ) )
               endif
           Next
        else
           // Pasar la lista a texto para mostrar por si precisa modificar lista
           aEval( aLista, {|c,n| cLista += c + CRLF } )
           cLista := Trim( cLista )
        endif

        if nOpc > 1 
          if MemoEdit( @cLista, 'Modificar, si precisa..' )
           aLista := {}
           nTotal := MLCount( cLista )
           // Devolver a la lista de nuevo los ya conformes..     
           For nI = 1 To nTotal
               if !EmpTy( AllTrim( MemoLine( cLista,, nI ) ) )
                   aadd( aLista, AllTrim( MemoLine( cLista,, nI ) ) )
               endif
           Next
           if ( !File( cFileSv ) .or. ( cTx != cLista ) ) .and. ;
                        MsgYesNo( 'Mascara: '+ cMasc + CRLF + ;
                        'Desea SALVAR?.' )
              MsgInfo( 'Mascara: ' + cMasc + CRLF + ;
                iif( MemoWrit( cFileSv, cLista ), '', ;
                                'NO pudo ser ' ) + 'SALVADA !' )

           endif
          else
          ? 'Ha Cancelado ..!'
           Return aLista
          endif
       endif
lExist := .t.

if ( lCargar )
        // lStat controla el CHANGE  q se produce al ir progresando
        // en aadir cada imagen del combobox de imagenes.
        lStat := .f.
                        // CARGANDO UNA DE MASCARAS ..!
                        aEval( aLista, {|c,n| ;
                      cFileBmp := c,;
                        aD := Directory( cFileBmp ), ;
                        iif( File( cFileBmp ) .and. aD[ 1, 2 ] > 0 .and. ;
                             !Empty( cFileBmp ) .and.;
                        Ascan( aImg, cFileBmp ) == 0,; // No verlos .. = .f.
                   ( aadd( aImg, cFileBmp ), CreateChild( cFileBmp, .f. ),;
                     aadd( aObjBmp, oBmpVer ) ),;
                                lExist := .f. ), ;
                          iif( !( lUsImg ), Eval( bVer ), Nil ) } )
                          // Tras el ultimo cargado, verlos en explorer
                          // si es Xp ..
        lStat := .t.
/*
                        // CARGANDO LAS RESPUESTAS, SI ES PSICO
                //if 'PSI' $ Upper( cMasc ) .and. 
                   If   !Empty( cLista := Memoread( 'Resp1.Psi' ) )
                        //  aResp := {}
                   aLista := {}
                   nTotal := Len( aImg )        //MLCount( cLista )
                   // Crear la lista de nuevo las respuestas  vacias..     
                   For nI = 1 To nTotal
                      //   if !EmpTy( AllTrim( MemoLine( cLista,, nI ) ) )
                           aadd( aLista, AllTrim( MemoLine( cLista,, nI ) ) )
                     //    endif
                   Next
                        aResp := aLista
                        oS2:SetText( 'R.:' + aResp[oLbxB1:nAt] )
                 endif
*/
endif
//  MsgList( aLista, 'aLista:' )
//  MsgList( aImg, 'aImg:' )

Return aLista
//
Static Function BuildMenu( cTarget )
local aL := {}, aLista := {}, nI := 1, oMn, oPrn, cApp, cMasc := Space( 250 )
local cNum := Space( 10 ), cTxt, aD := {} //oCarga, oBo1
         
      MENU oMn
         MENUITEM '&Archivo'

         MENU
         MENUITEM '&Abrir' ACTION ( lStat := .f.,;
                CreateChild( Eval( bGFile ) ), ;
                iif(lSel,aadd( aObjBmp, oBmpVer ),lSel := .t.), ;
                                lStat := .t. )

         MENUITEM '&Recientes'
         MENU

            MENUITEM oBo1 PROMPT '&Borrar Lista de recientes !' ;
            ACTION iif( !Empty( oMru1:aItems ) .and. ;
                MsgNoYes( 'Seguro de BORRAR Lista?..' ), ;
             ( oMru1:Clear(), oLi1:Disable(),;
            oBo1:Disable(), oCarga:Disable(), oWnd:Refresh() ), Nil )

            MENUITEM oLi1 PROMPT 'Borrar una &Linea' ;
            ACTION iif( !Empty( oMru1:aItems ),;
         ( Valorar( nI, oMru1:aItems, "WocMrImg.ini", oMn, 1 ), ;
         oWnd:Refresh() ),Nil )
 
            SEPARATOR

            MENUITEM oCarga PROMPT '&Cargar todos..' ;
            ACTION (  aLista := oMru1:aItems, lStat := .f.,;
                        aEval( aLista, {|c,n| ;
                      cFileBmp := AllTrim( substr( c:cPrompt, 3 ) ),;
                        aD := Directory( cFileBmp ), ;
                        iif( aD[ 1, 2 ] > 0 .and. ;
                        File( cFileBmp ) .and. !Empty( cFileBmp ) .and.;
                        Ascan( aImg, cFileBmp ) == 0,;
                  ( aadd( aImg, cFileBmp ), CreateChild( cFileBmp, .f. ), ;
                          aadd( aObjBmp, oBmpVer ),;
                       oMru1:Save( AllTrim( cFileBmp ) ) ), Nil ), ;
                 iif( !( lUsImg ), Eval( bVer ), Nil )  } ), lStat := .t. )

            MRU oMru1 ;
              FILENAME ".\WocMrImg.ini" ;     // .INI to manipulate. '\.' for local
              SECTION  "MRU-Imagenes" ;      // The name of the INI section
              ACTION ;  //  MsgInfo( cMruItem )  // cMruItem is automatically provided
              ( cFileBmp := cMruItem, ;
              aD := Directory( cFileBmp ), ;
              iif( File( cFileBmp ) .and. aD[ 1, 2 ] > 0 .and. Ascan( aImg, cFileBmp ) == 0, ;
                ( aadd( aImg, cFileBmp ), lStat := .f.,;
                CreateChild( cFileBmp ),aadd( aObjBmp, oBmpVer ),;
                        oMru1:Save( cFileBmp ), lStat := .t. ;
                         ), Nil ) ) ;
            MESSAGE  OemToAnsi( "Imgenes ..." ) ; // The message for all of them
            SIZE     15                    // The number of MRU items to manage

            SEPARATOR

         ENDMENU

                MENUITEM OemToAnsi( '&Mscaras..' )
                MENU
                MENUITEM OemToAnsi( 'Crear &Nueva' )  ;
                ACTION ( ;
                cMasc := cGetFile( '*.*', 'Elija VIA y un archivo ..' ), ;
                iif( !Empty( cMasc ), ;
                ( cMasc := FMasc( cMasc ), oMru2:Save( cMasc ), ;
                iif( !Empty( oMru2:aItems ), ;
                        (oBo2:Enable(), oLi2:Enable()), Nil ) ), Nil ) )
                        
                MENUITEM oBo2 PROMPT OemToAnsi( '&Borrar Lista de Mscaras !' ) ;
                ACTION iif( !Empty( oMru2:aItems ) .and. ;
                MsgNoYes( 'Seguro de BORRAR Lista?..' ), ;
   ( oMru2:Clear(), oBo2:Disable(), oLi2:Disable(), oWnd:Refresh() ), Nil )

                MENUITEM oLi2 PROMPT 'Borrar una &Linea' ;
                ACTION iif( !Empty( oMru2:aItems ),;
                ( Valorar( nI, oMru2:aItems, "WocMasc.ini", oMn, 2 ),;
                        oWnd:Refresh() ), Nil )

                MENUITEM oC2 PROMPT 'Carga al &Inicio' ;
                ACTION iif( !Empty( oMru2:aItems ),;
                Valorar( nI, oMru2:aItems, "WocMasc.ini", oMn, 2, .f. ), Nil )
 
                MRU oMru2 ;
                FILENAME ".\WocMasc.ini" ;     // .INI to manipulate. '\.' for local
                SECTION  "MRU-Aplicaciones" ;      // The name of the INI section
                ACTION ;  //  MsgInfo( cMruItem )  // cMruItem is automatically provided
                ( cMasc := cMruItem, CargaMasc( cMasc ) ) ;
                MESSAGE  OemToAnsi( "Cargar Mscaras de archivos ..." ) ; // The message for all of them
                SIZE     15                    // The number of MRU items to manage

         ENDMENU

         MENUITEM '&Guardar como ..' ACTION Copiar( cFileBmp, '', .f.,, .t. )

                SEPARATOR
                MENUITEM '&Exportar ..'
                MENU

                MENUITEM OemToAnsi( '&Elegir Aplicacin' ) ;
                ACTION ( ;
                Eval( {|| iif( Empty( oMru4:aItems ), ;
                  ( oMn := BuildMenu(), ;
                  oMru4:Save( 'EXPLORER' ), ;
        oMru4:Save( iif( IsWinNt(), 'MSPAINT', 'PBRUSH' ) ), ;
                oWnd:SetMenu( BuildMenu() ) ), Nil ) } ),;
                Eval( bRun ) )
                 
                MENUITEM oBo4 PROMPT '&Borrar Lista de Aplicaciones !' ;
                ACTION iif( !Empty( oMru4:aItems ) .and. ;
                MsgNoYes( 'Seguro de BORRAR Lista?..' ), ;
                ( oMru4:Clear(), oMn:Refresh(),;
                iif( Empty( oMru4:aItems ), ;
                  ( oMru4:Save( 'EXPLORER' ), ;
        oMru4:Save( iif( IsWinNt(), 'MSPAINT', 'PBRUSH' ) ), ;
                oWnd:SetMenu( BuildMenu() ) ), Nil ) ), Nil )

                MENUITEM oLi4 PROMPT 'Borrar una &Linea' ;
                ACTION iif( !Empty( oMru4:aItems ),;
              Valorar( nI, oMru4:aItems, "WocMrExe.ini", oMn, 4 ), Nil )
 
                MRU oMru4 ;
                FILENAME ".\WocMrExe.ini" ;     // .INI to manipulate. '\.' for local
                SECTION  "MRU-Aplicaciones" ;      // The name of the INI section
                ACTION ;  //  MsgInfo( cMruItem )  // cMruItem is automatically provided
                ( ;
                  cApp := Upper( cMruItem ), ;
                WaitRun( AllTrim( cApp ) + ;
                        ' ' + iif( !Empty( cFileBmp ), ;
                        iif( cApp == 'EXPLORER', cFilePath( cFileBmp ), ;
                                        cFileBmp ), '' ), 3 ) ;
                          ) ;
                MESSAGE  OemToAnsi( "Exportar ..." ) ; // The message for all of them
                SIZE     10                    // The number of MRU items to manage

                SEPARATOR

                ENDMENU

                SEPARATOR

                MENUITEM '&Imprimir' ;
            ACTION ( ;
            IIF( oBmpVer != Nil, ;
                           PrnBmp( , oBmpVer ),;
                MsgStop( 'NO se ha elegido IMAGEN !.' ) ),;
                cFileBmp := ;
                IIF( Empty( cFileBmp ) .and. (oLbxB1:nAt) > 0,;
                aImg[oLbxB1:nAt], cFileBmp ) )

                MENUITEM OemToAnsi( 'Me&n Impresoras' ) ACTION ;
                   iiF( !Empty( oPrn := TPrinter():New( '', .t., .f. ) ),;
                         ( oPrn:End() ), Nil )

                SEPARATOR

                MENUITEM '&Salir'     ACTION oWnd:End()

          ENDMENU

         oMn:AddMDI()
//         oMn:AddHelp()
       if  !( lUsImg )

       MENUITEM "Visualizador Windows" ;
       ACTION ( Eval( bVer ) )

//         oMn:Add( TMenuItem():New( "Visualizador Windows",;
  //                 "",,, { || Eval( bImg ), ;
    //                    WaitRun( 'EXPLORER' + ' ' + cTarget, 3 ) } ) )
       endif

      ENDMENU

      iif( Empty( oMru1:aItems ), ( oLi1:Disable(), ;
                        oCarga:Disable(), oBo1:Disable() ), )
      iif( Empty( oMru2:aItems ), ( oLi2:Disable(), oBo2:Disable() ), )
      iif( Empty( oMru4:aItems ), ( oLi4:Disable(), oBo4:Disable() ), )
                    /*
                iif( Empty( oMru4:aItems ), ;
                  ( oMn := BuildMenu(), oMru4:Save( 'EXPLORER' ), ;
        oMru4:Save( iif( IsWinNt(), 'MSPAINT', 'PBRUSH' ) ), ;
                oWnd:SetMenu( BuildMenu() ) ), Nil )
                      */
Return oMn

Static function Valorar( nI, aL, cFile, oMn, nMru, lDel )
local n, nX, c := ''

DEFAULT lDel := .t.     // Eliminar linea,  .f. = usarla para arrncar en inicio

                //aL := oMru4:aItems
        if lDel == .f. .and. nMru == 2 .and. ;
                        !EmpTy( MemoRead( cFIni ) ) .and. ;
                        MsgYesNo( OemToAnsi( 'Mascara de Inicio: ' + CRLF +;
                        AllTrim( MemoRead( cFIni ) ) + CRLF + CRLF + ;
                        'Desea SUPRIMIR?..' ) )

                  Ferase( cFIni )
                  oC2:SetCheck( .t. )
                  oWnd:SetMenu( BuildMenu() )
                  Return Nil
        endif

                aEval( aL, {|c,n|;
                  aL[n] := c:cPrompt, ;
                  aL[n] := SubsTr( AllTrim( aL[n] ), 3 ) } )
                  nI := Max( AsCan( aL, AllTrim(MemoRead( cFIni) ) ), 1 )
                  nI := xMsgList( aL, iif( lDel, 'Eliminar una LINEA ..',;
                  OemToAnsi('Elegir Mascara de Inicio..') ),,,,,;
                                                        '&Aceptar', nI )

                if nI > 0 .and. ;
                  MsgYesNo( alltrim( str( nI ) ) + '=> ' + ;
                                cvaltochar( aL[ nI ] ) +;
                                CRLF + CRLF + iif( lDel,;
                                'Desea BORRAR?.', ;
                                OemToAnsi('Mascara de Inicio?') ) )
                  if lDel
                    aDel( aL, nI )
                    aSize( aL, Len( aL ) -1 )
                    Ferase( cFile )
                  endif
                endif
                               
if lDel

oMn := BuildMenu()

for n = 1 to Len( aL )
        c := cValToChar( aL[n] )
        do case
        case nMru == 1
            oMru1:Save( c )
        case nMru == 2
            oMru2:Save( c )
        case nMru == 4
            oMru4:Save( c )
        endcase
next

oWnd:SetMenu( BuildMenu() )
else    // Archivo de mascara a cargar automaticamente
        MemoWrit( cFIni, AllTrim( aL[ nI ] ) )
endif

return Nil 
                                 
//----------------------------------------------------------------------------//
Static function MemoEdit( cText, cTitle, nTop, nLeft, nBottom, nRight, ;
                        lRead, cTip )

   local oFont, oDlg, oMemo, oBtnOk, oBtnCancel, oBtnHelp
   local uTemp := cText, aD := {} 
   local lOk   := .f.

   DEFAULT nTop := 9, nLeft := 9, nBottom := 22, nRight := 68.5,;
           cTitle := "MemoEdit", lRead := .f., cText := 'Texto..', ;
           cTip := 'Texto: ' + iif( lRead, 'Solo LECTURA ..', ;
                        'Editando ...' )
                                
   DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 0, -8

   DEFINE DIALOG oDlg FROM nTop, nLeft TO nBottom, nRight ;
      TITLE cTitle FONT oFont

   @ 4, 3 GET oMemo VAR uTemp MEMO OF oDlg PIXEL SIZE 100, 100

   oMemo:bGotFocus = { || oMemo:SetSel( 0, 0 ),;
                         oMemo:Goto( oMemo:GetLineCount() ),;
                         __Keyboard( Chr( VK_END ) ) }
        oMemo:bGotFocus := {|| oMemo:SetSel( 0, 0 ) }
        oMemo:lReadOnly := lRead
        oMemo:cToolTip  := cTip
                                
   @ 78,  90 BUTTON oBtnOk PROMPT "&Ok" SIZE 36, 13 PIXEL ;
      ACTION ( cText := uTemp, lOk := .t., oDlg:End() )

   @ 78, 134 BUTTON oBtnCancel PROMPT "&Cancel" SIZE 36, 13 PIXEL ;
      ACTION oDlg:End()

   @ 78, 176 BUTTON oBtnHelp PROMPT "&Help" SIZE 36, 13 PIXEL ;
      ACTION HelpTopic()

   ACTIVATE DIALOG oDlg ;
      ON INIT ( oMemo:SetSize( oDlg:nWidth() - 17, oDlg:nHeight() - 69 ),;
                oBtnOk:nTop      := oDlg:nHeight() - 57,;
                oBtnOk:nLeft     := oDlg:nWidth() - 250,;
                oBtnCancel:nTop  := oDlg:nHeight() - 57,;
                oBtnCancel:nLeft := oDlg:nWidth() - 167,;
                oBtnHelp:nTop    := oDlg:nHeight() - 57,;
                oBtnHelp:nLeft   := oDlg:nWidth() -  84 )

   cText := AllTrim( cText )

return lOk

//----------------------------------------------------------------------------//

Static function xMsgList( aData, cTitle, nTop, nLeft, nBottom, nRight, ;
                                                        cBtnTitle, nItem )

   local oFont, oDlg, oLst, oBtnClose
                                                                    
   if aData == nil .or. len(aData) == 0
      MsgStop("Incorrect parameter passed to function MsgList")
      return nil
   endif
                                           //22                      
   DEFAULT nTop := 9, nLeft := 9, nBottom := 22, nRight := 68.5,;
           cTitle := "Lista", cBtnTitle := "&Cerrar", nItem := 1

   DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 0, -8

   DEFINE DIALOG oDlg FROM nTop, nLeft TO nBottom, nRight ;
      TITLE cTitle FONT oFont ;
      STYLE nOr(WS_POPUP, WS_CAPTION, WS_BORDER, WS_SYSMENU, WS_THICKFRAME, WS_MAXIMIZEBOX)

   @ 4, 3 LISTBOX oLst VAR nItem ITEMS aData OF oDlg PIXEL SIZE 100, 100
                                                               //13
   @ 78, 176 BUTTON oBtnClose PROMPT cBtnTitle DEFAULT SIZE 36, 10 PIXEL ;
      ACTION oDlg:End()

   oDlg:bResized := {|| oLst:SetSize( oDlg:nWidth() - 17, oDlg:nHeight() - iif(LargeFonts(), 79, 69) ),;
                        oBtnClose:nTop    := oDlg:nHeight() - iif(LargeFonts(), 67, 57),;
                        oBtnClose:nLeft   := oDlg:nWidth() -  84 }

   ACTIVATE DIALOG oDlg CENTERED ON INIT Eval(oDlg:bResized)

return nItem

