// JUAN EUGENIO PLANELLES LAZAGA
// Fichero 	WOCGRAD.PRG - 14/02/2012 - Genera el solo una aplicacin que es llamada
// desde WOCUL3.EXE para disear combinaciones de colores degradados para fondo de ventanas o dilogos.
#include 'fivewin.ch'

sTatic nClrIni, nClrFin, nClrMas, nColores, oWnd, lVal := .t., nValDir, nInvTodos

Function Main( cFColor )
local oDlg, cTx, oIco, cFConf, cVal, cExt, nPos := 23, nClr1, nClr2, lInvert := .f.
local nPosInv := 25, nInvTodos := 50, lInvTodos := .f.

 nValDir    := 1
DEFAULT cFColor := "CFGRAVEN.001"

nPos := iif( SubsTr( cFColor, 6, 3 ) == "VEN", 23, 24 ) // separar vert/horiz entre vent y dialg
nPosInv := iif( SubsTr( cFColor, 6, 3 ) == "VEN", 25, 26 ) // separar vert/horiz entre vent y dialg
cExt := SubsTr( cFColor, 10, 3 )
nColores    := 2

   cFConf := "CONFIGUR." + cExt
   cVal := Trim( MemoRead( cFConf ) ) + Space( 20 )
   lVal := ( SubsTr( cVal, nPos, 1 ) != "N" )
   lInvert := ( SubsTr( cVal, nPosInv, 1 ) == "S" )
   lInvTodos := ( SubsTr( cVal, nInvTodos, 1 ) == "S" )
   lVal := lInvTodos  // para no cambiar su aplicacion
   
   nValDir    := SubsTr( cVal, nPos, 1 ) 
   nValDir    := at( nValDir, "SND" )
   nValDir    := MAX( nValDir, 1 )

//? cFConf, cFColor, cVal, lVal
cTx := AllTrim( memoread( cFColor ) )
nClrIni := Val( AllTrim( memoLine( cTx, , iif( lInVert, 2, 1 ) ) ) )
nClrFin := Val( AllTrim( memoLine( cTx, , iif( lInVert, 1, 2 ) ) ) )
if !Empty( AllTrim( memoLine( cTx, , 3 ) ) )
    nColores := 3
    nClrMas  := Val( AllTrim( memoLine( cTx, , 3 ) ) )
endif
nClrFin := iif( nClrFin == 0 .and. nClrIni == 0, CLR_WHITE, nClrFin )

DEFINE ICON oIco FILE "WOCUL3.ico"

		DEFINE WINDOW oDlg FROM 10, 10 TO 30, 80 ICON oIco ;
																		TITLE "Mostrando Colores Degradados .."

		ACTIVATE WINDOW oDlg ON PAINT gradpaint( hDC, oDlg )

Return Nil

static function gradpaint( hDC, oDlg )  //, oWnd )
local aGrad  //, hDC := oWnd:hDC
// nClrIni := CLR_BLUE ; nClrFin := CLR_HRED

/*
  aGrad := { ;
      { .25, CLR_BLUE, CLR_HBLUE }, ;
      { .25, CLR_HBLUE, CLR_BLUE }, ;
      { .25, CLR_GREEN, CLR_HGREEN }, ;
      { .25, CLR_HGREEN, CLR_GREEN } ;
      }
*/ 
//   GradientFill( hDC,  1, 1,100,100, aGrad, .t. )

if nColores == 3
  aGrad := { ;
      { .40, nClrIni, nClrFin },;
      { .60, nClrFin, nClrMas } }		//        { .30, nClrFin, nClrMas } }
else      
  aGrad := { ;
      { .50, nClrIni, nClrFin } }
endif

Do Case
Case nValDir == 3
   //oWnd:nHeight, oWnd:nWidth,
   DiagonalGradientFill( hDC, 1, 1, oDlg:nHeight, oDlg:nWidth, aGrad, lVal )    
OtherWise
   GradientFill( hDC, 1, 1, oDlg:nHeight, oDlg:nWidth, aGrad, lVal )    
//   GradientFill( hDC, 1, 1, oDlg:nBottom, oDlg:nRight, aGrad, lVal )
//   GradientFill( hDC,  1,1,110,220, aGrad, .f. )
EndCase

return nil

Static function DiagonalGradientFill( hDC, nTop, nLeft, nBottom, nRight, aGradInfo, lDirection )

   local nClr := 1, nClrs := Len( aGradInfo )
   local nSize, nStart, nEnd

   default lDirection := .T.


   if Empty( aGradInfo )
      return nil
   endif

   nSize    = ( nBottom - nTop ) + ( nRight - nLeft )
   nStart   = 0
   nEnd     = 0

   for nClr := 1 to nClrs

      nStart = nEnd  
      nEnd   += ( nSize * ( aGradInfo[ nClr ][ 1 ] ) )

      DiagonalGradient( hDC, ;
                       { nTop, nLeft, nBottom, nRight },;
                        aGradInfo[ nClr ][ 2 ], ;
                        aGradInfo[ nClr ][ 3 ], ;
                        lDirection, ;
                        nStart, ;
                        nEnd )
            
   next


return nil